"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseURL = void 0;
function parseURL(url, login, pass) {
    const parsedUrl = new URL(url);
    const { href, host, protocol, username, password } = parsedUrl;
    let hrefWithCredentials = `${protocol}//${login || username}:${pass || password}@${host}${href.split(host).slice(1).join(host)}`;
    let hrefWithNoCredentials = `${protocol}//${host}${href.split(host).slice(1).join(host)}`;
    if (!url.endsWith('/')) {
        hrefWithCredentials = hrefWithCredentials.replace(/\/+$/, '');
        hrefWithNoCredentials = hrefWithNoCredentials.replace(/\/+$/, '');
    }
    return {
        ...parsedUrl,
        hrefWithCredentials,
        hrefWithNoCredentials,
    };
}
exports.parseURL = parseURL;
if (typeof exports.default === 'function') {
    module.exports = exports.default;
    Object.assign(module.exports, exports);
}
