import { Arguments } from 'yargs-parser';
import { ValuesOf } from './tsUtils';
export declare let withFlagCredentials: boolean;
export declare const flagsWithDefaulValues: {
    'dry-run': boolean;
    'save-dev': boolean;
    'save-prod': boolean;
    'types-only': boolean;
    'ignore-package-json': boolean;
    'allow-prerelease': boolean;
    silent: boolean;
    registry: string;
    _auth: string;
    login: string;
    password: string;
    completion: boolean;
    version: boolean;
    help: boolean;
    ':make-autocompletion-flags': boolean;
    ':test-flags-run': boolean;
};
export declare const flagAliases: FlagAliases;
declare type FlagsWithDefaultValues = typeof flagsWithDefaulValues;
export declare type Flag = keyof FlagsWithDefaultValues;
export declare type FlagSynonym = Exclude<('P' | 'D' | 'r' | 'a' | 'ap' | 'c' | 'd' | 't' | 'i' | 'p' | 'l' | 'u' | 'username' | 'v' | 'h' | 's'), Flag>;
declare type FlagAliases = Record<Flag, FlagSynonym | FlagSynonym[]>;
interface ParsedCLIParams extends FlagsWithDefaultValues {
    _: Arguments['_'];
}
export declare const parsedCLIParams: ParsedCLIParams;
export declare function getConfigValueByFlagOrSynonym(key: Flag | FlagSynonym): ValuesOf<typeof flagsWithDefaulValues>;
export declare const makeFlagWithPrefix: (flag: string) => string;
export declare function isFlagOrSynonymInCommandLine(key: string): boolean;
export declare const flagStack: Partial<Record<Flag, Boolean>>;
export declare function getConfig<T extends Flag>(flag: T): FlagsWithDefaultValues[T];
export {};
